import '@/css/popup.css'

class Popup {
  private overlay: HTMLElement;
  private popup: HTMLElement;

  constructor() {
    this.overlay = document.createElement('div');
    this.overlay.classList.add('overlay');
    document.body.appendChild(this.overlay);

    this.popup = document.createElement('div');
    this.popup.classList.add('popup');
    document.body.appendChild(this.popup);

    this.overlay.addEventListener('click', () => {
      this.hide();
    });
  }

  show(content: string | HTMLElement): void {
    if (typeof content === 'string') {
      this.popup.innerHTML = content;
    } else {
      this.popup.innerHTML = '';
      this.popup.appendChild(content);
    }

    this.overlay.classList.add('show');
    this.popup.classList.add('show');
  }

  hide(): void {
    this.overlay.classList.remove('show');
    this.popup.classList.remove('show');
  }
}

const popup = new Popup();
export default popup;
