import '@/css/toast.css';

class Toast {
  private toastContainer: HTMLDivElement;

  constructor() {
    this.toastContainer = document.createElement("div");
    this.toastContainer.classList.add("toast-container");
    document.body.appendChild(this.toastContainer);
  }

  private show(message: string, type: string, duration: number = 3000): void {
    const toast = document.createElement("div");
    toast.classList.add("toast", type);

    toast.innerHTML = message;
    this.toastContainer.appendChild(toast);

    setTimeout(() => {
      toast.classList.add("show");
    }, 100);

    setTimeout(() => {
      toast.classList.remove("show");
      setTimeout(() => {
        this.toastContainer.removeChild(toast);
      }, 500);
    }, duration);
  }

  success(message: string, duration?: number): void {
    this.show(message, "success", duration);
  }

  error(message: string, duration?: number): void {
    this.show(message, "error", duration);
  }
}

const toast = new Toast();
export default toast;
